//using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class Game : MonoBehaviour
{
    // :
    [SerializeField]
    AudioSource audio;
    [SerializeField]
    AudioClip buljk;
    [SerializeField]
    AudioClip win;

    //  :
    private int level;
    //  :
    private int score;

    [SerializeField]
    GameObject imageWin;
    //  :
    private int nBalls;

    [SerializeField]
    GameObject prefabBall;
    //   :
    private bool gameOver;

    // :
    [SerializeField]
    Text textLevel;
    [SerializeField]
    Text textScore;
    [SerializeField]
    Text textBalls;


    //  
    void Start()
    {
        level = 1;
        NewGame();
    }


    //     
    void NewGame()
    {
        //    -  :
        score = 0;
        //     :
        imageWin.SetActive(false);

        //   = :
        nBalls = level;

        //     for:
        for (var i = 0; i < nBalls; ++i)
        {
            //  :
            var x = Random.Range(-4f, 3.8f);
            var y = Random.Range(1.7f, 2.8f);
            var coords = new Vector2(x, y);
            var ball = Instantiate(prefabBall, coords, Quaternion.identity);
            //    :
            var color = Random.ColorHSV(0.5f, 1, 0.5f, 1, 0.5f, 1);
            ball.GetComponent<SpriteRenderer>().color = color;
            //  :
            var r = Random.Range(0.5f, 0.8f);
            ball.transform.localScale = new Vector3(r, r, 1);
        }
        //   :
        gameOver = false;
    }

    //    
    void Update()
    {
        //  :
        if (gameOver) return;

        PrintInfo();
    }


    //   
    public void AddScore()
    {
        //    :
        audio.clip = buljk;
        audio.Play();

        //   :
        score += 10;
        //    
        //      :
        --nBalls;
        PrintInfo();

        //  :
        if (nBalls == 0)
            StartCoroutine(GameOver());
    }


    //  
    IEnumerator GameOver()
    {
        //   :
        audio.clip = win;
        audio.Play();
        //     :
        imageWin.SetActive(true);
        //  :
        gameOver = true;
        //    :
        ++level;
        //  3    :
        yield return new WaitForSeconds(3);
        NewGame();
    }


    //  
    private void PrintInfo()
    {
        //   :
        textLevel.text = string.Format(": {0}", level);
        //  :
        textScore.text = string.Format(": {0}", score);
        //  :
        textBalls.text = string.Format(": {0}", nBalls);
    }
}
